require "util"
require "defines"

game.oninit(function(event)
glob.dynamite = glob.dynamite or {}
end)

game.onevent(defines.events.onbuiltentity, function(event)
    if event.createdentity.name == "dynamite" then
        local i = #glob.dynamite+1
        glob.dynamite[i] = {}
        glob.dynamite[i].entity = event.createdentity
        glob.dynamite[i].tick = event.tick
        if glob.dynamite[i] then game.player.print("You placed dynamite! run?") end
    end
end)

game.onevent(defines.events.ontick, function(event)
    for index,dynamite in pairs(glob.dynamite) do
        if event.tick - dynamite.tick > 120 then
            if dynamite.entity.isvalid() then dynamite.entity.die() end
            if not dynamite.entity.isvalid() then table.remove(glob.dynamite,index) end
        end
    end
end)

game.onevent(defines.events.onentitydied, function(event)
    game.createentity{name="huge-explosion", position={x=event.entity.position.x, y=event.entity.position.y}}
    if event.entity.name == "dynamite" then
        game.player.print(serpent.block(event.entity.position))
        for k,v in pairs(glob.dynamite) do
            if event.entity.equals(v.entity) then table.remove(glob.dynamite,k) end
        end
        local ironore = 0
        local copperore = 0
        local coalore = 0
        for k, resource in pairs(game.findentities{{event.entity.position.x-1, event.entity.position.y-1},{event.entity.position.x+1,event.entity.position.y+1}}) do
            if resource.type == "resource" then 
                if resource.name == "iron-ore" then ironore = ironore + resource.amount resource.destroy()
                elseif resource.name == "copper-ore" then copperore = copperore + resource.amount resource.destroy()
                elseif resource.name == "coal" then coalore = coalore + resource.amount resource.destroy()
                end
            end
        end
        for k,nearbyentity in pairs(game.findentities{{event.entity.position.x-5, event.entity.position.y-5}, {event.entity.position.x+5, event.entity.position.y+5}}) do
            if nearbyentity.name == "dynamite" then for k,v in pairs(glob.dynamite) do if nearbyentity.equals(v.entity) then glob.dynamite[k].tick=glob.dynamite[k].tick-100 end end
            elseif nearbyentity.health then nearbyentity.damage(20, game.player.force)
            end
        end
        ironore, copperore, coalore = math.random(0, ironore), math.random(0, copperore), math.ceil(math.random(0, coalore)*.8)
        if ironore > 0 then game.createentity({ name="item-on-ground", position = {event.entity.position.x, event.entity.position.y}, stack={name="iron-ore", count=ironore}}) end
        if copperore > 0 then game.createentity({ name="item-on-ground", position = {event.entity.position.x, event.entity.position.y}, stack={name="copper-ore", count=copperore}}) end
        if coalore > 0 then game.createentity({ name="item-on-ground", position = {event.entity.position.x, event.entity.position.y}, stack={name="coal", count=coalore}}) end
    end
end)
